diff --git a/drivers/staging/lustre/lustre/ldlm/ldlm_request.c b/drivers/staging/lustre/lustre/ldlm/ldlm_request.c
index 35ba6f14d95f..75c9cdd89885 100644
--- a/drivers/staging/lustre/lustre/ldlm/ldlm_request.c
+++ b/drivers/staging/lustre/lustre/ldlm/ldlm_request.c
@@ -1850,8 +1850,9 @@ static int ldlm_chain_lock_for_replay(struct ldlm_lock *lock, void *closure)
 
 static int replay_lock_interpret(const struct lu_env *env,
 				 struct ptlrpc_request *req,
-				 struct ldlm_async_args *aa, int rc)
+				 void *_aa, int rc)
 {
+	struct ldlm_async_args *aa = _aa;
 	struct ldlm_lock     *lock;
 	struct ldlm_reply    *reply;
 	struct obd_export    *exp;
@@ -1978,7 +1979,7 @@ static int replay_one_lock(struct obd_import *imp, struct ldlm_lock *lock)
 	CLASSERT(sizeof(*aa) <= sizeof(req->rq_async_args));
 	aa = ptlrpc_req_async_args(req);
 	aa->lock_handle = body->lock_handle[0];
-	req->rq_interpret_reply = (ptlrpc_interpterer_t)replay_lock_interpret;
+	req->rq_interpret_reply = replay_lock_interpret;
 	ptlrpcd_add_req(req);
 
 	return 0;
diff --git a/drivers/staging/lustre/lustre/llite/dir.c b/drivers/staging/lustre/lustre/llite/dir.c
index 7f32a539d260..234abb7485bb 100644
--- a/drivers/staging/lustre/lustre/llite/dir.c
+++ b/drivers/staging/lustre/lustre/llite/dir.c
@@ -136,11 +136,12 @@
 struct page *ll_get_dir_page(struct inode *dir, struct md_op_data *op_data,
 			     __u64 offset)
 {
-	struct md_callback cb_op;
+	static struct md_callback cb_op = {
+		.md_blocking_ast = ll_md_blocking_ast,
+	};
 	struct page *page;
 	int rc;
 
-	cb_op.md_blocking_ast = ll_md_blocking_ast;
 	rc = md_read_page(ll_i2mdexp(dir), op_data, &cb_op, offset, &page);
 	if (rc)
 		return ERR_PTR(rc);
diff --git a/drivers/staging/lustre/lustre/llite/llite_internal.h b/drivers/staging/lustre/lustre/llite/llite_internal.h
index 4bc551279aa4..08ff257d45d0 100644
--- a/drivers/staging/lustre/lustre/llite/llite_internal.h
+++ b/drivers/staging/lustre/lustre/llite/llite_internal.h
@@ -504,16 +504,16 @@ struct ll_sb_info {
 
 	/* metadata stat-ahead */
 	unsigned int	      ll_sa_max;     /* max statahead RPCs */
-	atomic_t		  ll_sa_total;   /* statahead thread started
+	atomic_unchecked_t	  ll_sa_total;   /* statahead thread started
 						  * count
 						  */
-	atomic_t		  ll_sa_wrong;   /* statahead thread stopped for
+	atomic_unchecked_t	  ll_sa_wrong;   /* statahead thread stopped for
 						  * low hit ratio
 						  */
 	atomic_t		ll_sa_running;	/* running statahead thread
 						 * count
 						 */
-	atomic_t		  ll_agl_total;  /* AGL thread started count */
+	atomic_unchecked_t	  ll_agl_total;  /* AGL thread started count */
 
 	dev_t			  ll_sdev_orig; /* save s_dev before assign for
 						 * clustered nfs
diff --git a/drivers/staging/lustre/lustre/llite/llite_lib.c b/drivers/staging/lustre/lustre/llite/llite_lib.c
index e5c62f4ce3d8..9f82038dad26 100644
--- a/drivers/staging/lustre/lustre/llite/llite_lib.c
+++ b/drivers/staging/lustre/lustre/llite/llite_lib.c
@@ -113,10 +113,10 @@ static struct ll_sb_info *ll_init_sbi(struct super_block *sb)
 
 	/* metadata statahead is enabled by default */
 	sbi->ll_sa_max = LL_SA_RPC_DEF;
-	atomic_set(&sbi->ll_sa_total, 0);
-	atomic_set(&sbi->ll_sa_wrong, 0);
+	atomic_set_unchecked(&sbi->ll_sa_total, 0);
+	atomic_set_unchecked(&sbi->ll_sa_wrong, 0);
 	atomic_set(&sbi->ll_sa_running, 0);
-	atomic_set(&sbi->ll_agl_total, 0);
+	atomic_set_unchecked(&sbi->ll_agl_total, 0);
 	sbi->ll_flags |= LL_SBI_AGL_ENABLED;
 
 	/* root squash */
diff --git a/drivers/staging/lustre/lustre/llite/lproc_llite.c b/drivers/staging/lustre/lustre/llite/lproc_llite.c
index 13ec24d44b04..f7a6d1c6438d 100644
--- a/drivers/staging/lustre/lustre/llite/lproc_llite.c
+++ b/drivers/staging/lustre/lustre/llite/lproc_llite.c
@@ -686,9 +686,9 @@ static int ll_statahead_stats_seq_show(struct seq_file *m, void *v)
 		   "statahead total: %u\n"
 		   "statahead wrong: %u\n"
 		   "agl total: %u\n",
-		   atomic_read(&sbi->ll_sa_total),
-		   atomic_read(&sbi->ll_sa_wrong),
-		   atomic_read(&sbi->ll_agl_total));
+		   atomic_read_unchecked(&sbi->ll_sa_total),
+		   atomic_read_unchecked(&sbi->ll_sa_wrong),
+		   atomic_read_unchecked(&sbi->ll_agl_total));
 	return 0;
 }
 
diff --git a/drivers/staging/lustre/lustre/llite/rw26.c b/drivers/staging/lustre/lustre/llite/rw26.c
index 0cb70c3a1a0b..26f3a37873a7 100644
--- a/drivers/staging/lustre/lustre/llite/rw26.c
+++ b/drivers/staging/lustre/lustre/llite/rw26.c
@@ -354,10 +354,6 @@ static ssize_t ll_direct_IO_26(struct kiocb *iocb, struct iov_iter *iter)
 	if (!lli->lli_has_smd)
 		return -EBADF;
 
-	/* Check EOF by ourselves */
-	if (iov_iter_rw(iter) == READ && file_offset >= i_size_read(inode))
-		return 0;
-
 	/* FIXME: io smaller than PAGE_SIZE is broken on ia64 ??? */
 	if ((file_offset & ~PAGE_MASK) || (count & ~PAGE_MASK))
 		return -EINVAL;
diff --git a/drivers/staging/lustre/lustre/llite/statahead.c b/drivers/staging/lustre/lustre/llite/statahead.c
index 0677513476ec..4c7ea034647f 100644
--- a/drivers/staging/lustre/lustre/llite/statahead.c
+++ b/drivers/staging/lustre/lustre/llite/statahead.c
@@ -893,7 +893,7 @@ static int ll_agl_thread(void *arg)
 	CDEBUG(D_READA, "agl thread started: sai %p, parent %pd\n",
 	       sai, parent);
 
-	atomic_inc(&sbi->ll_agl_total);
+	atomic_inc_unchecked(&sbi->ll_agl_total);
 	spin_lock(&plli->lli_agl_lock);
 	sai->sai_agl_valid = 1;
 	if (thread_is_init(thread))
@@ -1010,7 +1010,7 @@ static int ll_statahead_thread(void *arg)
 	if (sbi->ll_flags & LL_SBI_AGL_ENABLED)
 		ll_start_agl(parent, sai);
 
-	atomic_inc(&sbi->ll_sa_total);
+	atomic_inc_unchecked(&sbi->ll_sa_total);
 	spin_lock(&lli->lli_sa_lock);
 	if (thread_is_init(sa_thread))
 		/* If someone else has changed the thread state
@@ -1123,7 +1123,7 @@ static int ll_statahead_thread(void *arg)
 
 		if (sa_low_hit(sai)) {
 			rc = -EFAULT;
-			atomic_inc(&sbi->ll_sa_wrong);
+			atomic_inc_unchecked(&sbi->ll_sa_wrong);
 			CDEBUG(D_READA, "Statahead for dir "DFID" hit ratio too low: hit/miss %llu/%llu, sent/replied %llu/%llu, stopping statahead thread: pid %d\n",
 			       PFID(&lli->lli_fid), sai->sai_hit,
 			       sai->sai_miss, sai->sai_sent,
diff --git a/drivers/staging/lustre/lustre/lmv/lmv_obd.c b/drivers/staging/lustre/lustre/lmv/lmv_obd.c
index cd19ce811e62..7dbb2b946acf 100644
--- a/drivers/staging/lustre/lustre/lmv/lmv_obd.c
+++ b/drivers/staging/lustre/lustre/lmv/lmv_obd.c
@@ -744,18 +744,16 @@ static int lmv_hsm_req_count(struct lmv_obd *lmv,
 	/* count how many requests must be sent to the given target */
 	for (i = 0; i < hur->hur_request.hr_itemcount; i++) {
 		curr_tgt = lmv_find_target(lmv, &hur->hur_user_item[i].hui_fid);
-		if (IS_ERR(curr_tgt))
-			return PTR_ERR(curr_tgt);
 		if (obd_uuid_equals(&curr_tgt->ltd_uuid, &tgt_mds->ltd_uuid))
 			nr++;
 	}
 	return nr;
 }
 
-static int lmv_hsm_req_build(struct lmv_obd *lmv,
-			     struct hsm_user_request *hur_in,
-			     const struct lmv_tgt_desc *tgt_mds,
-			     struct hsm_user_request *hur_out)
+static void lmv_hsm_req_build(struct lmv_obd *lmv,
+			      struct hsm_user_request *hur_in,
+			      const struct lmv_tgt_desc *tgt_mds,
+			      struct hsm_user_request *hur_out)
 {
 	int			i, nr_out;
 	struct lmv_tgt_desc    *curr_tgt;
@@ -766,8 +764,6 @@ static int lmv_hsm_req_build(struct lmv_obd *lmv,
 	for (i = 0; i < hur_in->hur_request.hr_itemcount; i++) {
 		curr_tgt = lmv_find_target(lmv,
 					   &hur_in->hur_user_item[i].hui_fid);
-		if (IS_ERR(curr_tgt))
-			return PTR_ERR(curr_tgt);
 		if (obd_uuid_equals(&curr_tgt->ltd_uuid, &tgt_mds->ltd_uuid)) {
 			hur_out->hur_user_item[nr_out] =
 				hur_in->hur_user_item[i];
@@ -777,8 +773,6 @@ static int lmv_hsm_req_build(struct lmv_obd *lmv,
 	hur_out->hur_request.hr_itemcount = nr_out;
 	memcpy(hur_data(hur_out), hur_data(hur_in),
 	       hur_in->hur_request.hr_data_len);
-
-	return 0;
 }
 
 static int lmv_hsm_ct_unregister(struct lmv_obd *lmv, unsigned int cmd, int len,
@@ -1058,17 +1052,15 @@ static int lmv_iocontrol(unsigned int cmd, struct obd_export *exp,
 		} else {
 			/* split fid list to their respective MDS */
 			for (i = 0; i < count; i++) {
+				unsigned int		nr, reqlen;
+				int			rc1;
 				struct hsm_user_request *req;
-				size_t reqlen;
-				int nr, rc1;
 
 				tgt = lmv->tgts[i];
 				if (!tgt || !tgt->ltd_exp)
 					continue;
 
 				nr = lmv_hsm_req_count(lmv, hur, tgt);
-				if (nr < 0)
-					return nr;
 				if (nr == 0) /* nothing for this MDS */
 					continue;
 
@@ -1080,13 +1072,10 @@ static int lmv_iocontrol(unsigned int cmd, struct obd_export *exp,
 				if (!req)
 					return -ENOMEM;
 
-				rc1 = lmv_hsm_req_build(lmv, hur, tgt, req);
-				if (rc1 < 0)
-					goto hsm_req_err;
+				lmv_hsm_req_build(lmv, hur, tgt, req);
 
 				rc1 = obd_iocontrol(cmd, tgt->ltd_exp, reqlen,
 						    req, uarg);
-hsm_req_err:
 				if (rc1 != 0 && rc == 0)
 					rc = rc1;
 				kvfree(req);
diff --git a/drivers/staging/lustre/lustre/lov/lov_internal.h b/drivers/staging/lustre/lustre/lov/lov_internal.h
index 07e5ede3e952..62827443633f 100644
--- a/drivers/staging/lustre/lustre/lov/lov_internal.h
+++ b/drivers/staging/lustre/lustre/lov/lov_internal.h
@@ -107,9 +107,9 @@ struct lov_request_set {
 	 */
 	struct obd_device		*set_obd;
 	int				set_count;
-	atomic_t			set_completes;
-	atomic_t			set_success;
-	atomic_t			set_finish_checked;
+	atomic_unchecked_t		set_completes;
+	atomic_unchecked_t		set_success;
+	atomic_unchecked_t		set_finish_checked;
 	struct llog_cookie		*set_cookies;
 	int				set_cookie_sent;
 	struct list_head			set_list;
diff --git a/drivers/staging/lustre/lustre/lov/lov_io.c b/drivers/staging/lustre/lustre/lov/lov_io.c
index d10157985ed9..def85ec03f6e 100644
--- a/drivers/staging/lustre/lustre/lov/lov_io.c
+++ b/drivers/staging/lustre/lustre/lov/lov_io.c
@@ -821,12 +821,32 @@ static void lov_empty_io_fini(const struct lu_env *env,
 }
 
 static void lov_empty_impossible(const struct lu_env *env,
-				 struct cl_io_slice *ios)
+				 const struct cl_io_slice *ios)
 {
 	LBUG();
 }
 
-#define LOV_EMPTY_IMPOSSIBLE ((void *)lov_empty_impossible)
+static int lov_empty_impossible2(const struct lu_env *env,
+				 const struct cl_io_slice *ios)
+{
+	LBUG();
+}
+
+static int lov_empty_impossible3(const struct lu_env *env,
+				 const struct cl_io_slice *slice,
+				 enum cl_req_type crt,
+				 struct cl_2queue *queue)
+{
+	LBUG();
+}
+
+static int lov_empty_impossible4(const struct lu_env *env,
+				 const struct cl_io_slice *slice,
+				 struct cl_page_list *queue, int from, int to,
+				 cl_commit_cbt cb)
+{
+	LBUG();
+}
 
 /**
  * An io operation vector for files without stripes.
@@ -836,32 +856,32 @@ static const struct cl_io_operations lov_empty_io_ops = {
 		[CIT_READ] = {
 			.cio_fini       = lov_empty_io_fini,
 #if 0
-			.cio_iter_init  = LOV_EMPTY_IMPOSSIBLE,
-			.cio_lock       = LOV_EMPTY_IMPOSSIBLE,
-			.cio_start      = LOV_EMPTY_IMPOSSIBLE,
-			.cio_end	= LOV_EMPTY_IMPOSSIBLE
+			.cio_iter_init  = lov_empty_impossible2,
+			.cio_lock       = lov_empty_impossible2,
+			.cio_start      = lov_empty_impossible2,
+			.cio_end	= lov_empty_impossible
 #endif
 		},
 		[CIT_WRITE] = {
 			.cio_fini      = lov_empty_io_fini,
-			.cio_iter_init = LOV_EMPTY_IMPOSSIBLE,
-			.cio_lock      = LOV_EMPTY_IMPOSSIBLE,
-			.cio_start     = LOV_EMPTY_IMPOSSIBLE,
-			.cio_end       = LOV_EMPTY_IMPOSSIBLE
+			.cio_iter_init = lov_empty_impossible2,
+			.cio_lock      = lov_empty_impossible2,
+			.cio_start     = lov_empty_impossible2,
+			.cio_end       = lov_empty_impossible
 		},
 		[CIT_SETATTR] = {
 			.cio_fini      = lov_empty_io_fini,
-			.cio_iter_init = LOV_EMPTY_IMPOSSIBLE,
-			.cio_lock      = LOV_EMPTY_IMPOSSIBLE,
-			.cio_start     = LOV_EMPTY_IMPOSSIBLE,
-			.cio_end       = LOV_EMPTY_IMPOSSIBLE
+			.cio_iter_init = lov_empty_impossible2,
+			.cio_lock      = lov_empty_impossible2,
+			.cio_start     = lov_empty_impossible2,
+			.cio_end       = lov_empty_impossible
 		},
 		[CIT_FAULT] = {
 			.cio_fini      = lov_empty_io_fini,
-			.cio_iter_init = LOV_EMPTY_IMPOSSIBLE,
-			.cio_lock      = LOV_EMPTY_IMPOSSIBLE,
-			.cio_start     = LOV_EMPTY_IMPOSSIBLE,
-			.cio_end       = LOV_EMPTY_IMPOSSIBLE
+			.cio_iter_init = lov_empty_impossible2,
+			.cio_lock      = lov_empty_impossible2,
+			.cio_start     = lov_empty_impossible2,
+			.cio_end       = lov_empty_impossible
 		},
 		[CIT_FSYNC] = {
 			.cio_fini   = lov_empty_io_fini
@@ -870,8 +890,8 @@ static const struct cl_io_operations lov_empty_io_ops = {
 			.cio_fini   = lov_empty_io_fini
 		}
 	},
-	.cio_submit                    = LOV_EMPTY_IMPOSSIBLE,
-	.cio_commit_async              = LOV_EMPTY_IMPOSSIBLE
+	.cio_submit                    = lov_empty_impossible3,
+	.cio_commit_async              = lov_empty_impossible4
 };
 
 int lov_io_init_raid0(const struct lu_env *env, struct cl_object *obj,
diff --git a/drivers/staging/lustre/lustre/lov/lov_obd.c b/drivers/staging/lustre/lustre/lov/lov_obd.c
index b23016f7ec26..e808e5216888 100644
--- a/drivers/staging/lustre/lustre/lov/lov_obd.c
+++ b/drivers/staging/lustre/lustre/lov/lov_obd.c
@@ -988,7 +988,7 @@ static int lov_getattr_interpret(struct ptlrpc_request_set *rqset,
 
 	/* don't do attribute merge if this async op failed */
 	if (rc)
-		atomic_set(&lovset->set_completes, 0);
+		atomic_set_unchecked(&lovset->set_completes, 0);
 	err = lov_fini_getattr_set(lovset);
 	return rc ? rc : err;
 }
@@ -1043,7 +1043,7 @@ static int lov_getattr_async(struct obd_export *exp, struct obd_info *oinfo,
 	}
 out:
 	if (rc)
-		atomic_set(&lovset->set_completes, 0);
+		atomic_set_unchecked(&lovset->set_completes, 0);
 	err = lov_fini_getattr_set(lovset);
 	return rc ? rc : err;
 }
@@ -1055,7 +1055,7 @@ static int lov_setattr_interpret(struct ptlrpc_request_set *rqset,
 	int err;
 
 	if (rc)
-		atomic_set(&lovset->set_completes, 0);
+		atomic_set_unchecked(&lovset->set_completes, 0);
 	err = lov_fini_setattr_set(lovset);
 	return rc ? rc : err;
 }
@@ -1117,7 +1117,7 @@ static int lov_setattr_async(struct obd_export *exp, struct obd_info *oinfo,
 		int err;
 
 		if (rc)
-			atomic_set(&set->set_completes, 0);
+			atomic_set_unchecked(&set->set_completes, 0);
 		err = lov_fini_setattr_set(set);
 		return rc ? rc : err;
 	}
@@ -1135,7 +1135,7 @@ int lov_statfs_interpret(struct ptlrpc_request_set *rqset, void *data, int rc)
 	int err;
 
 	if (rc)
-		atomic_set(&lovset->set_completes, 0);
+		atomic_set_unchecked(&lovset->set_completes, 0);
 
 	err = lov_fini_statfs_set(lovset);
 	return rc ? rc : err;
@@ -1168,7 +1168,7 @@ static int lov_statfs_async(struct obd_export *exp, struct obd_info *oinfo,
 		int err;
 
 		if (rc)
-			atomic_set(&set->set_completes, 0);
+			atomic_set_unchecked(&set->set_completes, 0);
 		err = lov_fini_statfs_set(set);
 		return rc ? rc : err;
 	}
diff --git a/drivers/staging/lustre/lustre/lov/lov_request.c b/drivers/staging/lustre/lustre/lov/lov_request.c
index 09dcaf484c89..8d02a468b1c7 100644
--- a/drivers/staging/lustre/lustre/lov/lov_request.c
+++ b/drivers/staging/lustre/lustre/lov/lov_request.c
@@ -41,9 +41,9 @@
 static void lov_init_set(struct lov_request_set *set)
 {
 	set->set_count = 0;
-	atomic_set(&set->set_completes, 0);
-	atomic_set(&set->set_success, 0);
-	atomic_set(&set->set_finish_checked, 0);
+	atomic_set_unchecked(&set->set_completes, 0);
+	atomic_set_unchecked(&set->set_success, 0);
+	atomic_set_unchecked(&set->set_finish_checked, 0);
 	set->set_cookies = NULL;
 	INIT_LIST_HEAD(&set->set_list);
 	atomic_set(&set->set_refcount, 1);
@@ -71,14 +71,14 @@ void lov_finish_set(struct lov_request_set *set)
 
 static int lov_set_finished(struct lov_request_set *set, int idempotent)
 {
-	int completes = atomic_read(&set->set_completes);
+	int completes = atomic_read_unchecked(&set->set_completes);
 
 	CDEBUG(D_INFO, "check set %d/%d\n", completes, set->set_count);
 
 	if (completes == set->set_count) {
 		if (idempotent)
 			return 1;
-		if (atomic_inc_return(&set->set_finish_checked) == 1)
+		if (atomic_inc_return_unchecked(&set->set_finish_checked) == 1)
 			return 1;
 	}
 	return 0;
@@ -90,9 +90,9 @@ static void lov_update_set(struct lov_request_set *set,
 	req->rq_complete = 1;
 	req->rq_rc = rc;
 
-	atomic_inc(&set->set_completes);
+	atomic_inc_unchecked(&set->set_completes);
 	if (rc == 0)
-		atomic_inc(&set->set_success);
+		atomic_inc_unchecked(&set->set_success);
 
 	wake_up(&set->set_waitq);
 }
@@ -192,7 +192,7 @@ static int common_attr_done(struct lov_request_set *set)
 	if (!set->set_oi->oi_oa)
 		return 0;
 
-	if (!atomic_read(&set->set_success))
+	if (!atomic_read_unchecked(&set->set_success))
 		return -EIO;
 
 	tmp_oa = kmem_cache_zalloc(obdo_cachep, GFP_NOFS);
@@ -239,7 +239,7 @@ int lov_fini_getattr_set(struct lov_request_set *set)
 	if (!set)
 		return 0;
 	LASSERT(set->set_exp);
-	if (atomic_read(&set->set_completes))
+	if (atomic_read_unchecked(&set->set_completes))
 		rc = common_attr_done(set);
 
 	lov_put_reqset(set);
@@ -332,7 +332,7 @@ int lov_fini_setattr_set(struct lov_request_set *set)
 	if (!set)
 		return 0;
 	LASSERT(set->set_exp);
-	if (atomic_read(&set->set_completes)) {
+	if (atomic_read_unchecked(&set->set_completes)) {
 		rc = common_attr_done(set);
 		/* FIXME update qos data here */
 	}
@@ -493,9 +493,9 @@ int lov_fini_statfs_set(struct lov_request_set *set)
 	if (!set)
 		return 0;
 
-	if (atomic_read(&set->set_completes)) {
+	if (atomic_read_unchecked(&set->set_completes)) {
 		rc = lov_fini_statfs(set->set_obd, set->set_oi->oi_osfs,
-				     atomic_read(&set->set_success));
+				     atomic_read_unchecked(&set->set_success));
 	}
 	lov_put_reqset(set);
 	return rc;
@@ -576,7 +576,7 @@ static int cb_statfs_update(void *cookie, int rc)
 	lov = &lovobd->u.lov;
 	osfs = set->set_oi->oi_osfs;
 	lov_sfs = oinfo->oi_osfs;
-	success = atomic_read(&set->set_success);
+	success = atomic_read_unchecked(&set->set_success);
 	/* XXX: the same is done in lov_update_common_set, however
 	 * lovset->set_exp is not initialized.
 	 */
@@ -604,7 +604,7 @@ static int cb_statfs_update(void *cookie, int rc)
 	if (set->set_oi->oi_flags & OBD_STATFS_PTLRPCD &&
 	    lov_set_finished(set, 0)) {
 		lov_statfs_interpret(NULL, set, set->set_count !=
-				     atomic_read(&set->set_success));
+				     atomic_read_unchecked(&set->set_success));
 	}
 
 	return 0;
diff --git a/drivers/staging/lustre/lustre/mdc/mdc_request.c b/drivers/staging/lustre/lustre/mdc/mdc_request.c
index f56ea643f9bf..6a146f45bedb 100644
--- a/drivers/staging/lustre/lustre/mdc/mdc_request.c
+++ b/drivers/staging/lustre/lustre/mdc/mdc_request.c
@@ -1219,9 +1219,9 @@ struct readpage_param {
  * in PAGE_SIZE (if PAGE_SIZE greater than LU_PAGE_SIZE), and the
  * lu_dirpage for this integrated page will be adjusted.
  **/
-static int mdc_read_page_remote(void *data, struct page *page0)
+static int mdc_read_page_remote(struct file *data, struct page *page0)
 {
-	struct readpage_param *rp = data;
+	struct readpage_param *rp = (struct readpage_param *)data;
 	struct page **page_pool;
 	struct page *page;
 	struct lu_dirpage *dp;
diff --git a/drivers/staging/lustre/lustre/obdclass/llog_swab.c b/drivers/staging/lustre/lustre/obdclass/llog_swab.c
index 8c4c1b3f1b45..630be4679db0 100644
--- a/drivers/staging/lustre/lustre/obdclass/llog_swab.c
+++ b/drivers/staging/lustre/lustre/obdclass/llog_swab.c
@@ -54,16 +54,20 @@ static void print_llogd_body(struct llogd_body *d)
 	CDEBUG(D_OTHER, "\tlgd_cur_offset: %#llx\n", d->lgd_cur_offset);
 }
 
-void lustre_swab_lu_fid(struct lu_fid *fid)
+void lustre_swab_lu_fid(void *_fid)
 {
+	struct lu_fid *fid = _fid;
+
 	__swab64s(&fid->f_seq);
 	__swab32s(&fid->f_oid);
 	__swab32s(&fid->f_ver);
 }
 EXPORT_SYMBOL(lustre_swab_lu_fid);
 
-void lustre_swab_ost_id(struct ost_id *oid)
+void lustre_swab_ost_id(void *_oid)
 {
+	struct ost_id *oid = _oid;
+
 	if (fid_seq_is_mdt0(oid->oi.oi_seq)) {
 		__swab64s(&oid->oi.oi_id);
 		__swab64s(&oid->oi.oi_seq);
@@ -80,8 +84,10 @@ static void lustre_swab_llog_id(struct llog_logid *log_id)
 	__swab32s(&log_id->lgl_ogen);
 }
 
-void lustre_swab_llogd_body(struct llogd_body *d)
+void lustre_swab_llogd_body(void *_d)
 {
+	struct llogd_body *d = _d;
+
 	print_llogd_body(d);
 	lustre_swab_llog_id(&d->lgd_logid);
 	__swab32s(&d->lgd_ctxt_idx);
@@ -94,8 +100,10 @@ void lustre_swab_llogd_body(struct llogd_body *d)
 }
 EXPORT_SYMBOL(lustre_swab_llogd_body);
 
-void lustre_swab_llogd_conn_body(struct llogd_conn_body *d)
+void lustre_swab_llogd_conn_body(void *_d)
 {
+	struct llogd_conn_body *d = _d;
+
 	__swab64s(&d->lgdc_gen.mnt_cnt);
 	__swab64s(&d->lgdc_gen.conn_cnt);
 	lustre_swab_llog_id(&d->lgdc_logid);
@@ -110,8 +118,10 @@ static void lustre_swab_ll_fid(struct ll_fid *fid)
 	__swab32s(&fid->f_type);
 }
 
-void lustre_swab_lu_seq_range(struct lu_seq_range *range)
+void lustre_swab_lu_seq_range(void *_range)
 {
+	struct lu_seq_range *range = _range;
+
 	__swab64s(&range->lsr_start);
 	__swab64s(&range->lsr_end);
 	__swab32s(&range->lsr_index);
@@ -294,8 +304,10 @@ static void print_llog_hdr(struct llog_log_hdr *h)
 	CDEBUG(D_OTHER, "\tllh_tail.lrt_len: %#x\n", h->llh_tail.lrt_len);
 }
 
-void lustre_swab_llog_hdr(struct llog_log_hdr *h)
+void lustre_swab_llog_hdr(void *_h)
 {
+	struct llog_log_hdr *h = _h;
+
 	print_llog_hdr(h);
 
 	lustre_swab_llog_rec(&h->llh_hdr);
diff --git a/drivers/staging/lustre/lustre/osc/osc_request.c b/drivers/staging/lustre/lustre/osc/osc_request.c
index 749781f022e2..29b770576ba3 100644
--- a/drivers/staging/lustre/lustre/osc/osc_request.c
+++ b/drivers/staging/lustre/lustre/osc/osc_request.c
@@ -179,8 +179,9 @@ static inline void osc_pack_req_body(struct ptlrpc_request *req,
 
 static int osc_getattr_interpret(const struct lu_env *env,
 				 struct ptlrpc_request *req,
-				 struct osc_async_args *aa, int rc)
+				 void *_aa, int rc)
 {
+	struct osc_async_args *aa = _aa;
 	struct ost_body *body;
 
 	if (rc != 0)
@@ -225,7 +226,7 @@ static int osc_getattr_async(struct obd_export *exp, struct obd_info *oinfo,
 	osc_pack_req_body(req, oinfo);
 
 	ptlrpc_request_set_replen(req);
-	req->rq_interpret_reply = (ptlrpc_interpterer_t)osc_getattr_interpret;
+	req->rq_interpret_reply = osc_getattr_interpret;
 
 	CLASSERT(sizeof(*aa) <= sizeof(req->rq_async_args));
 	aa = ptlrpc_req_async_args(req);
@@ -321,8 +322,9 @@ static int osc_setattr(const struct lu_env *env, struct obd_export *exp,
 
 static int osc_setattr_interpret(const struct lu_env *env,
 				 struct ptlrpc_request *req,
-				 struct osc_setattr_args *sa, int rc)
+				 void *_sa, int rc)
 {
+	struct osc_setattr_args *sa = _sa;
 	struct ost_body *body;
 
 	if (rc != 0)
@@ -372,8 +374,7 @@ int osc_setattr_async_base(struct obd_export *exp, struct obd_info *oinfo,
 		/* Do not wait for response. */
 		ptlrpcd_add_req(req);
 	} else {
-		req->rq_interpret_reply =
-			(ptlrpc_interpterer_t)osc_setattr_interpret;
+		req->rq_interpret_reply = osc_setattr_interpret;
 
 		CLASSERT(sizeof(*sa) <= sizeof(req->rq_async_args));
 		sa = ptlrpc_req_async_args(req);
@@ -495,7 +496,7 @@ int osc_punch_base(struct obd_export *exp, struct obd_info *oinfo,
 
 	ptlrpc_request_set_replen(req);
 
-	req->rq_interpret_reply = (ptlrpc_interpterer_t)osc_setattr_interpret;
+	req->rq_interpret_reply = osc_setattr_interpret;
 	CLASSERT(sizeof(*sa) <= sizeof(req->rq_async_args));
 	sa = ptlrpc_req_async_args(req);
 	sa->sa_oa = oinfo->oi_oa;
@@ -2091,8 +2092,9 @@ static int osc_enqueue_fini(struct ptlrpc_request *req,
 
 static int osc_enqueue_interpret(const struct lu_env *env,
 				 struct ptlrpc_request *req,
-				 struct osc_enqueue_args *aa, int rc)
+				 void *_aa, int rc)
 {
+	struct osc_enqueue_args *aa = _aa;
 	struct ldlm_lock *lock;
 	struct lustre_handle *lockh = &aa->oa_lockh;
 	enum ldlm_mode mode = aa->oa_mode;
@@ -2283,8 +2285,7 @@ int osc_enqueue_base(struct obd_export *exp, struct ldlm_res_id *res_id,
 				aa->oa_flags = NULL;
 			}
 
-			req->rq_interpret_reply =
-				(ptlrpc_interpterer_t)osc_enqueue_interpret;
+			req->rq_interpret_reply = osc_enqueue_interpret;
 			if (rqset == PTLRPCD_SET)
 				ptlrpcd_add_req(req);
 			else
@@ -2360,8 +2361,9 @@ int osc_cancel_base(struct lustre_handle *lockh, __u32 mode)
 
 static int osc_statfs_interpret(const struct lu_env *env,
 				struct ptlrpc_request *req,
-				struct osc_async_args *aa, int rc)
+				void *_aa, int rc)
 {
+	struct osc_async_args *aa = _aa;
 	struct obd_statfs *msfs;
 
 	if (rc == -EBADR)
@@ -2429,7 +2431,7 @@ static int osc_statfs_async(struct obd_export *exp,
 		req->rq_no_delay = 1;
 	}
 
-	req->rq_interpret_reply = (ptlrpc_interpterer_t)osc_statfs_interpret;
+	req->rq_interpret_reply = osc_statfs_interpret;
 	CLASSERT(sizeof(*aa) <= sizeof(req->rq_async_args));
 	aa = ptlrpc_req_async_args(req);
 	aa->aa_oi = oinfo;
diff --git a/drivers/staging/lustre/lustre/ptlrpc/layout.c b/drivers/staging/lustre/lustre/ptlrpc/layout.c
index 839ef3e80c1a..8912e22f2adb 100644
--- a/drivers/staging/lustre/lustre/ptlrpc/layout.c
+++ b/drivers/staging/lustre/lustre/ptlrpc/layout.c
@@ -778,8 +778,8 @@ struct req_capsule;
 	.rmf_name    = (name),					\
 	.rmf_flags   = (flags),					\
 	.rmf_size    = (size),					\
-	.rmf_swabber = (void (*)(void *))(swabber),		\
-	.rmf_dumper  = (void (*)(void *))(dumper)		\
+	.rmf_swabber = (swabber),				\
+	.rmf_dumper  = (dumper)					\
 }
 
 struct req_msg_field RMF_GENERIC_DATA =
@@ -1871,8 +1871,7 @@ static void *__req_capsule_get(struct req_capsule *pill,
 	msg = __req_msg(pill, loc);
 	LASSERT(msg);
 
-	getter = (field->rmf_flags & RMF_F_STRING) ?
-		(typeof(getter))lustre_msg_string : lustre_msg_buf;
+	getter = (field->rmf_flags & RMF_F_STRING) ?  lustre_msg_string : lustre_msg_buf;
 
 	if (field->rmf_flags & RMF_F_STRUCT_ARRAY) {
 		/*
